/*
 * bdd.hpp
 *      Author: Bergman, Cire
 */

#ifndef BDD_HPP_
#define BDD_HPP_

#include <map>
#include <vector>
#include "../core/intset.hpp"
#include "../util/util.hpp"

using namespace std;



/**
 * Node
 */
struct Node {

//	int				id;

	IntSet			state;
	int				longest_path;
//	bool			exact;

	int				relax_ub;

//	vector<Node*>	one_ancestors;
//	vector<Node*>	zero_ancestors;
//
//	Node*			one_arc;
//	Node*			zero_arc;

//	int				layer;


	/**
	 * Original node constructor for branch & bound. Also contains ancestors/descendants
	 * information if one wishes to save the BDD
	 */
	//	Node(IntSet &_state, int _longest_path, bool _exact)
	//	: state(_state), longest_path(_longest_path)//, exact(_exact)
	//	{
	//		zero_arc = NULL;
	//		one_arc = NULL;
	//
	//		layer = -1;
	//	}

	/**
	 * Node constructor if one wishes only to create a relaxation
	 */
	Node(IntSet &_state, int _longest_path)	: state(_state), longest_path(_longest_path)
	{
	}
};


struct BDD {

};


typedef map<IntSet*, Node*, IntSetLexLessThan> NodeMap;


/**
 * Node comparator by longest path
 */
struct CompareNodesLongestPath {
	bool operator()(const Node* nodeA, const Node* nodeB) const {
		return nodeA->longest_path > nodeB->longest_path;
	}
};

/**
 * Node comparator by state size
 */
struct CompareNodesStateSizeAscending {
	bool operator()(Node* nodeA, Node* nodeB) const {
		if( nodeA->state.get_size() != nodeB->state.get_size() )
			return nodeA->state.get_size() < nodeB->state.get_size();
		return nodeA->longest_path > nodeB->longest_path;
	}
};

/**
 * Node comparator by state size
 */
struct CompareNodesStateSizeDescending {
	bool operator()(Node* nodeA, Node* nodeB) const {
		if( nodeA->state.get_size() != nodeB->state.get_size() )
			return nodeA->state.get_size() > nodeB->state.get_size();
		return nodeA->longest_path > nodeB->longest_path;
	}
};



#endif /* BDD_HPP_ */
