
//
//#include <cassert>
//#include "setcover_solver.hpp"
//#include "../util/util.hpp"
//
//
//int SetCoverSolver::generate_relaxation(IntSet &initial_state, int initial_shortest_path) {
//
//
//	// ---------------------------------------
//	// 1. Initialize
//	// ---------------------------------------
//
//	// number of active variables per constraint
//	// !!! it is not considering the variables that were fixed up to this search node !!!
//	num_vars_per_const.resize(inst->num_cons, 0);
//	int cons = initial_state.get_first();
//	while( cons != initial_state.get_end() ) {
//		num_vars_per_const[cons] = inst->vars_in_const[cons].size();
//		cons = initial_state.get_next(cons);
//	}
//
//	selected_var.resize(inst->num_vars, false);
//
//
//	// ---------------------------------------
//	// 2. Relaxation
//	// ---------------------------------------
//
//	Node* initial_node = new Node(initial_state, initial_shortest_path, true);
//	node_list.clear();
//	node_list[&(initial_state)] = initial_node;
//
//	NodeMap::iterator node_it, existing_node_it;
//	Node* node;
//
//	int layer = 1;
//
//	//int current_vertex = choose_next_vertex();
//	int current_var = choose_next_vertex();
//	while ( current_var != -1 ) {
//	//while ( current_var < inst->num_vars ) {
//
////		cout << "\n\n\n\n ====================================================== \n\n";
////		cout << "Layer " << layer << " - current vertex: " << current_var << endl;
//
//		assert( current_var >= 0 && current_var < inst->num_vars );
//		layer++;
//
////		// iterate through the nodes in the node list
////		cout << "(Before) state list: " << endl;
////		for( NodeMap::iterator node_it = node_list.begin();
////				node_it != node_list.end();
////				node_it++ )
////		{
////			cout << "\tstate: " << *(node_it->first);
////			cout << " - longest path: " << node_it->second->longest_path;
////			cout << " - exact? " << node_it->second->exact;
////			cout << endl;
////		}
//
//
////		cout << "\nCurrent variable: " << current_var << endl;
//
//		/*
//		 * 1. Take the nodes that contains constraints containing current vertex
//		 */
//
//		nodes_layer.clear();
//
//		bool node_to_be_added;
//
//		node_it = node_list.begin();
//		while( node_it != node_list.end() )	{
//
//			node_to_be_added = false;
//
//			// iterator through the constraints of the state, checking if the
//			// vertex is in one of these states
//			cons = node_it->second->state.get_first();
//			while( cons != node_it->second->state.get_end() && !node_to_be_added) {
//				if( inst->is_var_in_const[cons][current_var] ) {
//					node_to_be_added = true;
//				}
//				cons = node_it->second->state.get_next(cons);
//			}
//
//			if( node_to_be_added ) {
//
//				// add node to current layer list
//				nodes_layer.push_back(node_it->second);
//
//				// erase element from the list
//				node_list.erase(node_it++);
//
//			} else {
//				++node_it;
//			}
//		}
//
////		cout << "\nBefore merging: " << endl;
////		for( vector<Node*>::iterator it = nodes_layer.begin(); it != nodes_layer.end(); ++it ) {
////			cout << "\t " << (*it)->state << " - " << (*it)->longest_path;
////			cout << " - exact? " << (*it)->exact << endl;
////		}
//
//
//		cout << "Layer " << (layer) << " - current vertex: " << current_var;
//		cout << " - pool size: " << node_list.size();
//		cout << " - before merge: " << nodes_layer.size();
//		cout << endl;
//
//		/*
//		 * 2. Merging
//		 */
//		if( width != EXACT_BDD && (int)nodes_layer.size() > width ) {
//			relax_layer_shortestpath();
//		}
//
////		cout << "\nAfter merging: " << endl;
////		for( vector<Node*>::iterator it = nodes_layer.begin(); it != nodes_layer.end(); ++it ) {
////			cout << "\t " << (*it)->state << " - " << (*it)->longest_path;
////			cout << " - exact? " << (*it)->exact << endl;
////		}
//
//
//		/**
//		 * 3. Branching
//		 */
//
//		bool kill_zero_node;
//		int node_count = 0;
//
//		// update active variables counter
//		for( vector<int>::iterator c = inst->consts_of_a_var[current_var].begin();
//				c != inst->consts_of_a_var[current_var].end();
//				c++ )
//		{
//			assert( num_vars_per_const[*c] != 0 );
//			num_vars_per_const[*c]--;
//		}
//
//		// branch on the nodes in the layer list
//
//		Node* branch_node;
//		for( vector<Node*>::iterator it = nodes_layer.begin(); it != nodes_layer.end(); ++it ) {
//
//			branch_node = (*it);
//
//			// **** one arc ****
//			node = new Node(branch_node->state, branch_node->longest_path+inst->weights[current_var], branch_node->exact);
//			for( vector<int>::iterator c = inst->consts_of_a_var[current_var].begin();
//					c != inst->consts_of_a_var[current_var].end();
//					c++ )
//			{
//				node->state.remove(*c);
//			}
//
//			existing_node_it = node_list.find(&(node->state));
//			if( existing_node_it != node_list.end() ) {
//
//				update_node_match(existing_node_it->second, node);
//				delete node;
//
//			} else {
//				node_list[&(node->state)] = node;
//				node_count++;
//
////				// update active state counter
////				eligible_vertex = node->state.get_first();
////				while( eligible_vertex != node->state.get_end() ) {
////					in_state_counter[ eligible_vertex] ++;
////					eligible_vertex = node->state.get_next(eligible_vertex);
////				}
//			}
//
//
//			// **** zero arc ****
//			kill_zero_node = false;
//			for( vector<int>::iterator c = inst->consts_of_a_var[current_var].begin();
//					c != inst->consts_of_a_var[current_var].end() && !kill_zero_node;
//					c++ )
//			{
//				kill_zero_node = (num_vars_per_const[*c] == 0) && branch_node->state.contains(*c);
//			}
//
//			if( !kill_zero_node ) {
//				existing_node_it = node_list.find(&(branch_node->state));
//				if( existing_node_it != node_list.end() ) {
//
//					update_node_match(existing_node_it->second, branch_node);
//					delete branch_node;
//
//				} else {
//					node_list[&(branch_node->state)] = branch_node;
//					node_count++;
//
////					// update active state counter
////					eligible_vertex = branch_node->state.get_first();
////					while( eligible_vertex != branch_node->state.get_end() ) {
////						in_state_counter[ eligible_vertex] ++;
////						eligible_vertex = branch_node->state.get_next(eligible_vertex);
////					}
//				}
//			}
//		}
//
//		cout << "\tnew nodes: " << node_count << endl;
//		current_var = choose_next_vertex();
//
////		// iterate through the nodes in the node list
////		cout << "(After) state list: " << endl;
////		for( NodeMap::iterator node_it = node_list.begin();
////				node_it != node_list.end();
////				node_it++ )
////		{
////			cout << "\tstate: " << *(node_it->first);
////			cout << " - longest path: " << node_it->second->longest_path;
////			cout << " - exact? " << node_it->second->exact;
////			cout << endl;
////		}
//	}
//
//	int lb = node_list.begin()->second->longest_path;
//
//	return lb;
//}
//
//
//int SetCoverSolver::generate_restriction(IntSet &initial_state, int initial_shortest_path) {
//	return -1;
//}
//
//
//int SetCoverSolver::choose_next_vertex() {
//
//	static int time = 0;
//
//	if( time == 0 ) {
//		time++;
//		return 31;
//	}
//	else if( time == 1) {
//		time++;
//		return 38;
//	}
//	else if( time == 2 ) {
//		time++;
//		return 75;
//	}
//	else if( time == 3 ) {
//		time++;
//		return 116;
//	}
//	else if( time == 4 ) {
//		time++;
//		return 127;
//	}
//	else if( time == 5 ) {
//		time++;
//		return 189;
//	}
//
//
//	else if( time == 11 ) {
//		time++;
//		return 21;
//	}
//
//	else if( time == 12 ) {
//		time++;
//		return 50;
//	}
//
//	else if( time == 13 ) {
//		time++;
//		return 88;
//	}
//
//	else if( time == 14 ) {
//		time++;
//		return 90;
//	}
//
//	else if( time == 15 ) {
//		time++;
//		return 173;
//	}
//
//	else if( time == 16 ) {
//		time++;
//		return 177;
//	}
//
//
//	time++;
//
//	int selected = -1;
//	int counter_min = INF;
//	int counter_var;
//
//	int cons;
//
//	for( int v = 0; v < inst->num_vars; v++ ) {
//
//		if( selected_var[v] )
//			continue;
//
//		counter_var = 0;
//
//		NodeMap::iterator node_it = node_list.begin();
//		while( node_it != node_list.end() )	{
//
//			cons = node_it->second->state.get_first();
//			while( cons != node_it->second->state.get_end() ) {
//				if( inst->is_var_in_const[cons][v] ) {
//					counter_var++;
//					break;
//				}
//				cons = node_it->second->state.get_next(cons);
//			}
//
//			node_it++;
//		}
//
//		//cout << "\t\tvar: " << v << " - counter: " << counter_var << endl;
//
//		if( counter_var < counter_min ) {
//			counter_min = counter_var;
//			selected = v;
//		}
//	}
//
//	if( selected != -1 ) {
//		selected_var[selected] = true;
//	}
//
//	return selected;
//
////	int min = INF;
////	int selected_vertex = -1;
////	for( int i = 0; i < inst->graph->n_vertices; i++ ) {
////		if( in_state_counter[i] > 0 && in_state_counter[i] < min ) {
////			selected_vertex = i;
////			min = in_state_counter[i];
////		}
////	}
////
////	return selected_vertex;
//
//	return -1;
//}
//
//
//
///**
// * Merge nodes to meet maximum width.
// */
//void SetCoverSolver::relax_layer_shortestpath() {
//
//////	if( !relax ) {
//////		cout << "node pool: " << nodes_layer.size() + node_list.size() << " - layer: " << layer << endl;
//////		relax = true;
//////	}
////
////	sort(nodes_layer.begin(), nodes_layer.end(), CompareNodesLongestPath());
////
////	/**
////	 * 1. Merge nodes
////	 */
////	if( nodes_layer[width-1]->exact ) {
////
////		//cout << "\t\tAdded " << nodes_layer[width-1]->state << " to temporary branch nodes" << endl;
////
////		temporary_branch_nodes.push_back(new Node(nodes_layer[width-1]->state, nodes_layer[width-1]->longest_path, false));
////		nodes_layer[width-1]->exact = false;
////	}
////
////	IntSet* state = &(nodes_layer[width-1]->state);
////	for( vector<Node*>::iterator node = nodes_layer.begin()+width; node != nodes_layer.end(); ++node) {
////		state->union_with((*node)->state);
////		if( (*node)->exact ) {
////			temporary_branch_nodes.push_back(*node);
////			//cout << "\t\tAdded " << (*node)->state << " to temporary branch nodes" << endl;
////		} else {
////			delete (*node);
////		}
////	}
////	nodes_layer.resize(width);
////
////	/**
////	 * 2. Equivalence test on this new node
////	 */
////	for( vector<Node*>::iterator node = nodes_layer.begin(); node != nodes_layer.end()-1; ++node) {
////		if( (*node)->state.equals_to(*state) ) {
////
////			// delete the last node
////			delete nodes_layer.back();
////
////			// remove it from queue
////			nodes_layer.pop_back();
////
////			// we do not need to do this, because the longest path in *node
////			// is longer than the W-1-th node
////
//////			// copy node to temporary, setting it as false
//////			if( (*node)->exact ) {
//////				temporary_branch_nodes.push_back(new Node((*node)->state, (*node)->longest_path, false));
//////				(*node)->exact = false;
//////
//////				cout << "\t\tAdded " << (*node) << " to temporary branch nodes" << endl;
//////			}
////
////			break;
////		}
////	}
//}
//
//
//
///**
// * Restrict nodes to meet maximum width.
// */
//void SetCoverSolver::restrict_layer_shortestpath() {
//
////	sort(nodes_layer.begin(), nodes_layer.end(), CompareNodesLongestPath());
////
////	/**
////	 * 1. Merge nodes
////	 */
////	for( vector<Node*>::iterator node = nodes_layer.begin()+width; node != nodes_layer.end(); ++node) {
////		delete (*node);
////	}
////	nodes_layer.resize(width);
//}
//
//
//
