/*
 * --------------------------------------------------------
 * Instance data structures - Implementation
 * --------------------------------------------------------
 */

#include <cstdlib>
#include <iostream>
#include <vector>

#include "instance.hpp"

using namespace std;


/**
 * Assign weights
 */
void IndepSetInst::assign_weights() {

  srand(0);
  weights = new int[graph->n_vertices];

  for( int i = 0; i < graph->n_vertices; i++ ) {
    //weights[i] = (1+graph->n_vertices-graph->adj_list[i].size())*3 + rand()%10;
    //weights[i] = graph->n_vertices-graph->adj_list[i].size();
	  weights[i] = 1;
  }

}


///**
// * Reorder graph
// */
//void IndepSetInst::reorder(vector<int> &mapping) {
//
//    // replace current graph and weights
//    Graph* tmp = new Graph(graph, mapping);
//    delete graph;
//    graph = tmp;
//
//    // replace weights
//    int* tmp_weights_inc = new int[graph->n_vertices];
//    int* tmp_weights_exc = new int[graph->n_vertices];
//    for( int i = 0; i < graph->n_vertices; i++ ) {
//        tmp_weights_inc[mapping[i]] = weights_inclusion[i];
//        tmp_weights_exc[mapping[i]] = weights_exclusion[i];
//    }
//
//    delete[] weights_inclusion;
//    delete[] weights_exclusion;
//    weights_inclusion = tmp_weights_inc;
//    weights_exclusion = tmp_weights_exc;
//}


///** Compute distance variance */
//long int IndepSetInst::compute_distance_variance() {
//
//  long int variance = 0;
//
//  // for( int i = 0; i < graph->n_vertices; i++ ) {
//  //   for( int j = i+1; j < graph->n_vertices; j++ ) {
//  //     if( graph->is_adj(i,j) ) {
//  // 	variance += (i-j) < 0 ? (-1)*(i-j) : (i-j);
//  //     }
//  //   }
//  // }
//
//  for( int i = 0; i < graph->n_vertices; i++ ) {
//    for( int j = i+1; j < graph->n_vertices; j++ ) {
//      if( graph->is_adj(i,j) ) {
//  	//variance += (i-j) < 0 ? (-1)*(i-j) : (i-j);
//
//	if( j-i <= 10 )
//	  variance++;
//      }
//    }
//  }
//
//  return variance;
//}


/**
 * read instance for set covering
 */
void SetCoverInst::read_orlib(char* filename) {

    ifstream input(filename);

    input >> num_cons;
    input >> num_vars;

    consts_of_a_var.resize(num_vars);
    vars_in_const.resize(num_cons);
    is_var_in_const.resize(num_cons);

    for( int i = 0; i < num_cons; i++ ) {
    	is_var_in_const[i].resize(num_vars, false);
    }

    weights = new int[num_vars];
    for( int i = 0; i < num_vars; i++ ) {
        input >> weights[i];
    }

    int k, elem;
    for( int c = 0; c < num_cons; c++ ) {
        input >> k;
        for( int i = 0; i < k; i++ ) {
            input >> elem;
            elem--;
            vars_in_const[c].push_back(elem);
            consts_of_a_var[elem].push_back(c);
            is_var_in_const[c][elem] = true;
        }
    }

    input.close();

    // !!! preprocess !!!
    //preprocess();
}





