/*
 * ------------------------------------
 * General Utilities
 * ------------------------------------
 */

#ifndef UTIL_HPP_
#define UTIL_HPP_

#include <limits>
#include <vector>

using namespace std;

/**
 * -------------------------------------------------------------
 * Macros
 * -------------------------------------------------------------
 */

#define MIN(_a_,_b_)              ((_a_ < _b_) ? _a_ : _b_)
#define MAX(_a_,_b_)              ((_a_ > _b_) ? _a_ : _b_)
#define FLOOR(_a_)                ( (int)_a_ )
#define CEIL(_a_)                 ( ((int)_a_ == _a_) ? _a_ : (((int)_a_)+1) )
//#define ABS(_a_)                    ( _a_ < 0 ? (-1)*_a_ : _a_ )

struct IndexComparatorDescending {
    int* v;
    IndexComparatorDescending(int* _v) : v(_v) { }
    bool operator()(const int a, const int b) {
        return( v[a] < v[b] );
    }
};

struct IndexComparatorDescendingSTL {
    vector<int> &v;
    IndexComparatorDescendingSTL(vector<int> &_v) : v(_v) { }
    bool operator()(const int a, const int b) {
        return( v[a] > v[b] );
    }
};

struct IndexComparatorAscendingSTL {
    vector<int> &v;
    IndexComparatorAscendingSTL(vector<int> &_v) : v(_v) { }
    bool operator()(const int a, const int b) {
        return( v[a] < v[b] );
    }
};



/**
 * -------------------------------------------------------------
 * Constants
 * -------------------------------------------------------------
 */

const int   INF_WIDTH   = -1;         /**< infinite width */
const int   INF   		= std::numeric_limits<int>::max();

#endif /* UTIL_HPP_ */
